# harness.py
import sys
import clr

from System import *
from System.IO import *
from System.Text import *
from System.Net import *

clr.AddReference('System.Web')
from System.Web import *

def getVS(url):
  wc = WebClient()
  bytes = wc.DownloadData(url)
  html = Encoding.ASCII.GetString(bytes)
  start = html.IndexOf('id="__VIEWSTATE"', 0) + 24
  end = html.IndexOf('"', start)
  vs = html.Substring(start, end-start)
  return vs

def getEV(url):
  wc = WebClient()
  bytes = wc.DownloadData(url)
  html = Encoding.ASCII.GetString(bytes)
  start = html.IndexOf('id="__EVENTVALIDATION"', 0) + 30
  end = html.IndexOf('"', start)
  ev = html.Substring(start, end-start)
  return ev

try:
  print '\nBegin IronPython Request-Response testing'
  print sys.argv[0]
  url = 'http://localhost/MiniCalc/Default.aspx'
  print '\nURL under test = ' + url + '\n'
  testCases = 'testCases.txt'

  numPass = numFail = 0

  fin = open(testCases, 'r')
  for line in fin:
    print '======================================================================'
    (caseid,value1,value2,operation,decimals,action,expected) = line.split('|')
    
    expected = 'value="' + expected.Trim() + '" id="TextBox3"'
    data = 'TextBox1=' + value1 + '&TextBox2=' + value2 + '&Operation=' + operation + '&DropDownList1=' + decimals + '&Button1=' + action
  
    print 'Test case: ' + caseid
    print 'Input    : ' + data
    print 'Expected : ' + expected

    vs = getVS(url)
    ev = getEV(url)
    vs = HttpUtility.UrlEncode(vs)
    ev = HttpUtility.UrlEncode(ev)
    data = data + "&__VIEWSTATE=" + vs + "&__EVENTVALIDATION=" + ev
 
    buffer = Encoding.ASCII.GetBytes(data)
    req = HttpWebRequest.Create(url)
    req.Method = 'POST'
    req.ContentType = 'application/x-www-form-urlencoded'
    req.ContentLength = buffer.Length

    reqst = req.GetRequestStream()
    reqst.Write(buffer, 0, buffer.Length)
    #reqst.Flush()
    reqst.Close()

    res = req.GetResponse()
    resst = res.GetResponseStream()
    sr = StreamReader(resst)

    html = sr.ReadToEnd()
    sr.Close()
    resst.Close()
  
    if html.IndexOf(expected) >= 0:
      print 'Pass'
      numPass = numPass + 1
    else:
      print '**FAIL**'
      numFail = numFail + 1

    print '======================================================================\n'

    # end main processing loop

  fin.close()

  print '\nNumber pass = ' + str(numPass)
  print 'Number fail = ' + str(numFail)  
  print '\nEnd test run\n'

except:
  print 'Fatal: ', sys.exc_info()[0]


# end script

 